/**
 * DO NOT EDIT
 *
 * This file was automatically generated by
 *   https://github.com/Polymer/tools/tree/master/packages/gen-typescript-declarations
 *
 * To modify these typings, edit the source file(s):
 *   api-type-documentation.js
 */


// tslint:disable:variable-name Describing an API that's defined elsewhere.
// tslint:disable:no-any describes the API as best we are able today

import {PolymerElement} from '@polymer/polymer/polymer-element.js';

import {html} from '@polymer/polymer/lib/utils/html-tag.js';

import {AmfHelperMixin} from '@api-components/amf-helper-mixin/amf-helper-mixin.js';

declare namespace ApiElements {

  /**
   * `api-type-documentation`
   *
   * A documentation module for RAML types (resources) using AMF data model.
   *
   * ## Styling
   *
   * `<api-type-documentation>` provides the following custom properties and mixins for styling:
   *
   * Custom property | Description | Default
   * ----------------|-------------|----------
   * `--api-type-documentation` | Mixin applied to this elment | `{}`
   * `--arc-font-headline` | Theme mixin, applied to the title | `{}`
   * `--api-type-documentation-title` | Mixin applied to the title | `{}`
   * `--api-type-documentation-title-narrow` | Mixin applied to the title in narrow layout | `{}`
   */
  class ApiTypeDocumentation extends
    ApiElements.AmfHelperMixin(
    Object) {

    /**
     * Generated AMF json/ld model form the API spec.
     * The element assumes the object of the first array item to be a
     * type of `"http://raml.org/vocabularies/document#Document`
     * on AMF vocabulary.
     *
     * It is only usefult for the element to resolve references.
     */
    amfModel: object|any[]|null;

    /**
     * `raml-aware` scope property to use.
     */
    aware: string|null|undefined;

    /**
     * A type definition to render.
     * This should be a one of the following AMF types:
     *
     * - `http://www.w3.org/ns/shacl#NodeShape` (Object)
     * - `http://raml.org/vocabularies/shapes#UnionShape` (Union)
     * - `http://raml.org/vocabularies/shapes#ArrayShape` (Array)
     * - `http://raml.org/vocabularies/shapes#ScalarShape` (single property)
     */
    type: object|any[]|null;

    /**
     * Computed value, title of the type.
     */
    readonly typeTitle: string|null|undefined;

    /**
     * Computed value of method description from `method` property.
     */
    readonly description: string|null|undefined;

    /**
     * Computed value from current `method`. True if the model contains
     * custom properties (annotations in RAML).
     */
    readonly hasCustomProperties: boolean|null|undefined;

    /**
     * Computed value, true when passed model represents a schema
     * (like XML)
     */
    readonly isSchema: boolean|null|undefined;

    /**
     * Set to render a mobile friendly view.
     */
    narrow: boolean|null|undefined;

    /**
     * A media type to use to generate examples.
     */
    mediaType: string|null|undefined;

    /**
     * Computes `description` property
     *
     * @param shape AMF model for data type
     */
    _computeDescription(shape: object|null): String|null|undefined;

    /**
     * Computes `typeTitle` property
     *
     * @param shape AMF model for data type
     */
    _computeTitle(shape: object|null): String|null|undefined;

    /**
     * Computes value for `isSchema` property.
     *
     * @param shape AMF `supportedOperation` model
     */
    _computeIsSchema(shape: object|null): Boolean|null;
  }
}

declare global {

  interface HTMLElementTagNameMap {
    "api-type-documentation": ApiElements.ApiTypeDocumentation;
  }
}
